package ru.mousecray.plants.items;

import net.minecraft.advancements.CriteriaTriggers;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.common.EnumPlantType;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.block.state.IBlockState;
import ru.mousecray.plants.blocks.ListBlocks;
import net.minecraftforge.common.IPlantable;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.util.EnumFacing;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumHand;
import net.minecraft.world.World;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;

public class CaveSeeds extends Item implements IPlantable {

    public CaveSeeds() {
        setUnlocalizedName("cave_seeds");
        setRegistryName("cave_seeds");
        //  
        setCreativeTab(CreativeTabs.MATERIALS);
    }

    @Override
    // ,     
    public EnumActionResult onItemUse(EntityPlayer player, World world, BlockPos pos, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        ItemStack itemstack = player.getHeldItem(hand);
        IBlockState state = world.getBlockState(pos);
        if (facing == EnumFacing.UP && player.canPlayerEdit(pos.offset(facing), facing, itemstack) && state.getBlock() == Blocks.COBBLESTONE && world.isAirBlock(pos.up())) {
            world.setBlockState(pos.up(), ListBlocks.CAVE_CROPS.getDefaultState());

            if (player instanceof EntityPlayerMP) {
                CriteriaTriggers.PLACED_BLOCK.trigger((EntityPlayerMP)player, pos.up(), itemstack);
            }

            itemstack.shrink(1);
            return EnumActionResult.SUCCESS;
        }
        else {
            return EnumActionResult.FAIL;
        }
    }

    @Override
    //  .      EnumTypePlant
    public EnumPlantType getPlantType(IBlockAccess world, BlockPos pos) {
        return EnumPlantType.Crop;
    }

    @Override
    //  
    public IBlockState getPlant(IBlockAccess world, BlockPos pos) {
        return ListBlocks.CAVE_CROPS.getDefaultState();
    }
}